
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Template Classes &#8212; Battery SOH 2022 documentation</title>
    
  <link href="../_static/css/theme.css" rel="stylesheet" />
  <link href="../_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="../_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/basic.css" />
    
  <link rel="preload" as="script" href="../_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="../index.html">
  <img src="../_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="../search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    
  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
              
              <div class="toc-item">
                

<nav id="bd-toc-nav">
    
</nav>
              </div>
              
              <div class="toc-item">
                
              </div>
              
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  <div class="section" id="template-classes">
<h1>Template Classes<a class="headerlink" href="#template-classes" title="Permalink to this headline">¶</a></h1>
<p>Corresponds to the <code class="docutils literal notranslate"><span class="pre">Template_Classes</span></code> module.</p>
<p>Notice that for each new dataset integrated, you’ll have to add the respective
values of <code class="docutils literal notranslate"><span class="pre">C_nominal</span></code>, <code class="docutils literal notranslate"><span class="pre">V_nominal</span></code> and <code class="docutils literal notranslate"><span class="pre">Q_nominal</span></code> to the
<a class="reference internal" href="LSTM.html#LSTM.Torch_Dataset_LSTM" title="LSTM.Torch_Dataset_LSTM"><code class="xref py py-class docutils literal notranslate"><span class="pre">Torch_Dataset_LSTM</span></code></a> class for each of the <code class="xref py py-mod docutils literal notranslate"><span class="pre">LSTM</span></code>,
<code class="xref py py-mod docutils literal notranslate"><span class="pre">LSTM_chemistry</span></code> and <code class="xref py py-mod docutils literal notranslate"><span class="pre">LSTM_with_norm</span></code> modules
(<a class="reference internal" href="Models.html"><span class="doc">Models</span></a>).</p>
<span class="target" id="module-Template_Classes"></span><dl class="py class">
<dt class="sig sig-object py" id="Template_Classes.Raw_Dataset">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">Template_Classes.</span></span><span class="sig-name descname"><span class="pre">Raw_Dataset</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">raw_file</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">battery_number</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Template_Classes.html#Raw_Dataset"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Template_Classes.Raw_Dataset" title="Permalink to this definition">¶</a></dt>
<dd><p>Class for saving the dataset raw data as is.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>The following are required attributes.</p>
</div>
<dl class="simple">
<dt>Name<span class="classifier">str</span></dt><dd><p>Battery name (“B000X”)</p>
</dd>
<dt>cycle<span class="classifier">list(Raw_Dataset.Raw_Cycle)</span></dt><dd><p>List of the cycle objects</p>
</dd>
</dl>
<dl class="py class">
<dt class="sig sig-object py" id="Template_Classes.Raw_Dataset.Raw_Cycle">
<em class="property"><span class="pre">class</span> </em><span class="sig-name descname"><span class="pre">Raw_Cycle</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">cycle</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">index</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Template_Classes.html#Raw_Dataset.Raw_Cycle"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Template_Classes.Raw_Dataset.Raw_Cycle" title="Permalink to this definition">¶</a></dt>
<dd><p>Class for storing Cycle data from raw battery data</p>
<p>In some datasets, charge and discharge data come together in one file,
there’s no problem with that, you can save them as one single cycle
here (not for the clean class).
Check <code class="xref py py-mod docutils literal notranslate"><span class="pre">MIT_Classes</span></code> to see how this is handled there.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>The following are required attributes.</p>
</div>
<dl class="simple">
<dt>number<span class="classifier">int</span></dt><dd><p>The cycle number.</p>
</dd>
<dt>type<span class="classifier">{‘charge’, ‘discharge’}</span></dt><dd><p>The cycle type.</p>
</dd>
<dt>amb_T<span class="classifier">float</span></dt><dd><p>The ambient temperature in which the battery was cycled [ºC]</p>
</dd>
<dt>data<span class="classifier">list(Raw_Dataset.Raw_Cycle.Raw_Data)</span></dt><dd><p>List with the actual data objects</p>
</dd>
</dl>
<dl class="py class">
<dt class="sig sig-object py" id="Template_Classes.Raw_Dataset.Raw_Cycle.Raw_Data">
<em class="property"><span class="pre">class</span> </em><span class="sig-name descname"><span class="pre">Raw_Data</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">data</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">type</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'discharge'</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Template_Classes.html#Raw_Dataset.Raw_Cycle.Raw_Data"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Template_Classes.Raw_Dataset.Raw_Cycle.Raw_Data" title="Permalink to this definition">¶</a></dt>
<dd><p>Class for storing the actual raw data.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>The following are required attributes.</p>
</div>
<dl class="simple">
<dt>time<span class="classifier">array like</span></dt><dd><p>Time array [s]</p>
</dd>
<dt>meas_i<span class="classifier">array like</span></dt><dd><p>Measured Current array [A]</p>
</dd>
<dt>meas_v<span class="classifier">array like</span></dt><dd><p>Measured Voltage array [V]</p>
</dd>
<dt>capacity<span class="classifier">float</span></dt><dd><p>Capacity value for the charge [A.h] (for discharge cycles).</p>
</dd>
</dl>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>The following are recommended attributes for when the
corresponding data is available.</p>
</div>
<dl class="simple">
<dt>meas_t<span class="classifier">array like</span></dt><dd><p>Measured temperature [ºC]</p>
</dd>
<dt>meas_q<span class="classifier">array like</span></dt><dd><p>Measured capacity [A.h]</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="Template_Classes.Clean_Dataset">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">Template_Classes.</span></span><span class="sig-name descname"><span class="pre">Clean_Dataset</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">Battery</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">i_cutoff</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0.02</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">min_len</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">threshold</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0.1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">z_lim</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">3</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Template_Classes.html#Clean_Dataset"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Template_Classes.Clean_Dataset" title="Permalink to this definition">¶</a></dt>
<dd><p>Class for cleaning and storing clean data</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>The following are required attributes.</p>
</div>
<dl class="simple">
<dt>Name<span class="classifier">str</span></dt><dd><p>Battery name (“B00XX”).</p>
</dd>
<dt>capacity_curve<span class="classifier">array like</span></dt><dd><p>A 2D array where the first column is the cycle number and the second is
the capacity value [A.h] associated to it.</p>
</dd>
<dt>cycle_couple<span class="classifier">list(tuple(Clean_Dataset.Clean_Dataset_Cycle))</span></dt><dd><p>A list with the cleaned charge and discharge cycles (respectively) that
are associated one with the other (the charge cycle is always the one
that comes immediately after the discharge cycle).</p>
</dd>
<dt>C_rate<span class="classifier">float</span></dt><dd><p>The C rate associated to the battery for nondimensionning the
current [A].</p>
</dd>
<dt>Q_nominal<span class="classifier">float</span></dt><dd><p>The battery’s nominal capacity (for nondimensionning the SOH) [A.h].</p>
</dd>
<dt>V_nominal<span class="classifier">float</span></dt><dd><p>The battery’s nominal voltage (for nondimensionning the voltage) [V].</p>
</dd>
</dl>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>The following are recommended attributes.</p>
<p>This has the purpose of simplifying things, but you’ll still have to
define them in the Dataset classes individually. That’s why it’s just
recommended.</p>
</div>
<dl class="simple">
<dt>couples<span class="classifier">list(tuple(int))</span></dt><dd><p>When the charge and discharge data are in separate cycles, we need to
first find the related couples. This will save their numbers so they can
later be called.</p>
</dd>
</dl>
<dl class="py method">
<dt class="sig sig-object py" id="Template_Classes.Clean_Dataset.separate_and_clean">
<span class="sig-name descname"><span class="pre">separate_and_clean</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">cycle</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">i_cutoff</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">min_len</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">threshold</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Template_Classes.html#Clean_Dataset.separate_and_clean"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Template_Classes.Clean_Dataset.separate_and_clean" title="Permalink to this definition">¶</a></dt>
<dd><p>Separate cycles (if needed) and cleans them.</p>
<p>I recommend looking at
<a class="reference internal" href="COIN.html#Coin_Classes.Clean_Cell.separate_coin_cycles" title="Coin_Classes.Clean_Cell.separate_coin_cycles"><code class="xref py py-func docutils literal notranslate"><span class="pre">Coin_Classes.Clean_Cell.separate_coin_cycles()</span></code></a> and
<a class="reference internal" href="Cleaning.html#Cleaning.Input_outliers_v3" title="Cleaning.Input_outliers_v3"><code class="xref py py-func docutils literal notranslate"><span class="pre">Cleaning.Input_outliers_v3()</span></code></a>.</p>
</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="Template_Classes.Clean_Dataset.Clean_Dataset_Cycle">
<em class="property"><span class="pre">class</span> </em><span class="sig-name descname"><span class="pre">Clean_Dataset_Cycle</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">cycle</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">i_cutoff</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">min_len</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">threshold</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0.1</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Template_Classes.html#Clean_Dataset.Clean_Dataset_Cycle"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Template_Classes.Clean_Dataset.Clean_Dataset_Cycle" title="Permalink to this definition">¶</a></dt>
<dd><p>Creates a clean cycle class</p>
<dl class="py class">
<dt class="sig sig-object py" id="Template_Classes.Clean_Dataset.Clean_Dataset_Cycle.Clean_Data_Class">
<em class="property"><span class="pre">class</span> </em><span class="sig-name descname"><span class="pre">Clean_Data_Class</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">data</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Template_Classes.html#Clean_Dataset.Clean_Dataset_Cycle.Clean_Data_Class"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Template_Classes.Clean_Dataset.Clean_Dataset_Cycle.Clean_Data_Class" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</dd></dl>

</dd></dl>

</div>


              </div>
              
              
              <div class='prev-next-bottom'>
                

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="../_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2022, Antonio ROCHA AZEVEDO.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>